Imports System.Web.Security
Imports System.Data.OleDb

Public Class LoginPage
    Inherits System.Web.UI.Page
    Protected WithEvents txtUsername As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
    Protected WithEvents chkRemember As System.Web.UI.WebControls.CheckBox
    Protected WithEvents btnLogin As System.Web.UI.WebControls.Button
    Protected WithEvents Form3 As System.Web.UI.HtmlControls.HtmlForm
    Protected WithEvents lblMessage As System.Web.UI.WebControls.Label
    Protected WithEvents hprNewUser As System.Web.UI.WebControls.HyperLink

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    ' this constants decides whether the user name is validated the
    ' entries in web.config or by using a custom validation mechanism
    ' that relies on some other technique (eg a database of users)
#Const USE_CUSTOM_COOKIES = True

    ' the user is attempting to log in

    Private Sub btnLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogin.Click
        ' you can replace the following line with a call to the 
        ' AuthenticateUser routine for custom authentication

        If FormsAuthentication.Authenticate(txtUsername.Text, txtPassword.Text) Then
            ' the user name has been found in web.config

#If USE_CUSTOM_COOKIES = False Then
            ' use transient or permanent default cookies
            FormsAuthentication.RedirectFromLoginPage(txtUsername.Text, chkRemember.Checked)
#Else
            ' use custom cookies that, if the user decides to remember
            ' her password, expire after one week
            RedirectFromLoginPageEx(txtUsername.Text, chkRemember.Checked, 7)
#End If

        Else
            ' the user couldn't be authenticated
            lblMessage.Text = "Invalid user name or password"
        End If
    End Sub


    ' this procedure checks the user name against a database of users
    ' (it is provided as an example, as no user database is provided
    '  with this demo)

    ' replace this with a real connection string
    Dim PasswordDBConnString As String = "... a connection string ..."

    Function AuthenticateUser(ByVal username As String, ByVal password As String) As Boolean
        ' Open the connection to the database holding user names and passwords.
        Dim cn As New OleDbConnection(PasswordDBConnString)
        cn.Open()
        ' Read the record for this user.
        Dim cmd As New OleDbCommand("SELECT * FROM Users WHERE UserName=?", cn)
        cmd.Parameters.Add("username", username)
        Dim dr As OleDbDataReader = cmd.ExecuteReader(CommandBehavior.SingleRow)

        If dr.Read AndAlso dr("Password") = password Then
            ' Authenticate user if there is a record and the password is correct.
            AuthenticateUser = True
        End If
        ' Close the DataReader (and the connection).
        dr.Close()
    End Function

    ' A custom routine that works like FormsAuthentication.RedirectFromLoginPage
    ' but lets you control the authentication cookie's expiration date.

    Function RedirectFromLoginPageEx(ByVal username As String, ByVal persistentCookie As Boolean, Optional ByVal expirationDays As Integer = -1) As Boolean
        ' Get the URL of the requested resource.
        Dim url As String = FormsAuthentication.GetRedirectUrl(username, persistentCookie)
        ' Create the authentication cookie.
        ' (The cookie path can be omitted, because it defaults to "/", the entire site.)
        FormsAuthentication.SetAuthCookie(username, persistentCookie, "/")

        If persistentCookie And expirationDays > 0 Then
            ' Get a reference to the cookie just created.
            Dim cookie As HttpCookie = Response.Cookies(FormsAuthentication.FormsCookieName)
            ' Set its expiration date.
            cookie.Expires = Now.AddDays(expirationDays)
            ' Uncomment next line to ensure the cookie can travel only over https.
            'cookie.Secure = True
        End If

        ' Redirect to the resource that was requested originally.
        Response.Redirect(url)
    End Function

End Class
